From 21fc4569728a9ceb83135f27210c8775858ed12a Mon Sep 17 00:00:00 2001
From: Endi Sukma Dewata <edewata@redhat.com>
Date: Fri, 2 Nov 2012 14:34:29 -0400
Subject: [PATCH] Updated certificate.png and no-certificate.png paths.

---
 dogtag/common-ui/shared/admin/console/config/certrequestpanel.vm  | 8 ++++----
 .../shared/docroot/ra/admin/console/config/certrequestpanel.vm    | 8 ++++----
 .../shared/docroot/tps/admin/console/config/certrequestpanel.vm   | 8 ++++----
 3 files changed, 12 insertions(+), 12 deletions(-)

diff --git a/dogtag/common-ui/shared/admin/console/config/certrequestpanel.vm b/dogtag/common-ui/shared/admin/console/config/certrequestpanel.vm
index 3eb5ebdf91fbafe811cc5c8169b03f0f4e195bc6..0502834e4c23aed75293194d8fbfb8f8124b2eba 100644
--- a/dogtag/common-ui/shared/admin/console/config/certrequestpanel.vm
+++ b/dogtag/common-ui/shared/admin/console/config/certrequestpanel.vm
@@ -133,20 +133,20 @@ Press the [Next] button once all certificates have been generated successfully.
   <td>&nbsp;</td>
 #if ($item.getCert() == "...paste certificate here...") 
   <td><font color=red>action required</font><br>
-<img alt="" src="../img/no-certificate.png"/></td>
+<img alt="" src="/pki/images/no-certificate.png"/></td>
 #elseif ($item.getCert() == "...certificate be generated internally...")
 <td>
-  <img alt="" src="../img/no-certificate.png"/><br>
+  <img alt="" src="/pki/images/no-certificate.png"/><br>
   certificate will be generated internally
   </td>
 #elseif ($item.getCert() == "")
   <td>
-<img alt="" src="../img/no-certificate.png"/><br>
+<img alt="" src="/pki/images/no-certificate.png"/><br>
   No Certificate Generated. Please import.<br>
   </td>
 #else
   <td>
-<img alt="" src="../img/certificate.png"/><br>
+<img alt="" src="/pki/images/certificate.png"/><br>
   Certificate Generated Successfully
   </td>
 #end
diff --git a/dogtag/ra-ui/shared/docroot/ra/admin/console/config/certrequestpanel.vm b/dogtag/ra-ui/shared/docroot/ra/admin/console/config/certrequestpanel.vm
index 883cb65897643d5f35dca86de3856a3b34f2e5b7..f1327db473ff5e49703acc489f4ceeaebddfbdb4 100644
--- a/dogtag/ra-ui/shared/docroot/ra/admin/console/config/certrequestpanel.vm
+++ b/dogtag/ra-ui/shared/docroot/ra/admin/console/config/certrequestpanel.vm
@@ -133,22 +133,22 @@ Press the [Next] button once all certificates have been generated successfully.
   <td>&nbsp;</td>
 #if ($item.getCert() == "...paste certificate here...") 
   <td><font color=red>action required</font><br>
-<img src="../img/no-certificate.png"/></td>
+<img src="/pki/images/no-certificate.png"/></td>
 #else
   #if ($item.getCert() == "...certificate be generated internally...")
 <td>
-  <img src="../img/no-certificate.png"/><br>
+  <img src="/pki/images/no-certificate.png"/><br>
   certificate will be generated internally
   </td>
   #else
     #if ($item.getCert() == "")
   <td>
-<img src="../img/no-certificate.png"/><br>
+<img src="/pki/images/no-certificate.png"/><br>
   No Certificate Generated. Please import.<br>
   </td>
     #else
   <td>
-<img src="../img/certificate.png"/><br>
+<img src="/pki/images/certificate.png"/><br>
   Certificate Generated Successfully
   </td>
     #end
diff --git a/dogtag/tps-ui/shared/docroot/tps/admin/console/config/certrequestpanel.vm b/dogtag/tps-ui/shared/docroot/tps/admin/console/config/certrequestpanel.vm
index 9a4462354d8f712415288d484a429d957a666569..632b27c34927af7bd3a5f7ddd394422d160d1908 100644
--- a/dogtag/tps-ui/shared/docroot/tps/admin/console/config/certrequestpanel.vm
+++ b/dogtag/tps-ui/shared/docroot/tps/admin/console/config/certrequestpanel.vm
@@ -132,22 +132,22 @@ Press the [Next] button once all certificates have been generated successfully.
   <td>&nbsp;</td>
 #if ($item.getCert() == "...paste certificate here...") 
   <td><font color=red>action required</font><br>
-<img src="../img/no-certificate.png"/></td>
+<img src="/pki/images/no-certificate.png"/></td>
 #else
   #if ($item.getCert() == "...certificate be generated internally...")
 <td>
-  <img src="../img/no-certificate.png"/><br>
+  <img src="/pki/images/no-certificate.png"/><br>
   certificate will be generated internally
   </td>
   #else
     #if ($item.getCert() == "")
   <td>
-<img src="../img/no-certificate.png"/><br>
+<img src="/pki/images/no-certificate.png"/><br>
   No Certificate Generated. Please import.<br>
   </td>
     #else
   <td>
-<img src="../img/certificate.png"/><br>
+<img src="/pki/images/certificate.png"/><br>
   Certificate Generated Successfully
   </td>
     #end
-- 
1.7.12.1